package rpgEngine.Resources;


import java.io.BufferedReader;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.Dictionary;
import java.util.Hashtable;

import rpgEngine.Data.Abstract.World.Terrain;

public class TerrainPool {

	private static TerrainPool instance;
	private Dictionary<Integer,Terrain> items;
	
	private TerrainPool() {
		items = new Hashtable<Integer,Terrain>();
		loadData();
	}
	
	
	public static TerrainPool getInstance() {
		if(instance == null) {
			instance = new TerrainPool();
		}
		
		return instance;
	}
	
	
	public Terrain getPoolItem(Integer i) {
		Terrain item = null;
		
		try 
		{
			item = items.get(i);	
		}
		catch(Exception e) 
		{
			return null;	
		}
		
		return item;
	}
	
	
	private void loadData() {	
		String filename = "terrain.cfg";
		String[] columns = null;
		InputStream fileStream = null;
		BufferedReader reader = null;
		String line = "";
		Terrain terrain = null;
		
		//Open File
		try {
			fileStream = this.getClass().getResourceAsStream("Config/" + filename);
			reader = new BufferedReader(new InputStreamReader(fileStream));
		}
		catch(Exception e) {
			System.err.println("Error openning file" + filename);
			System.err.println(e.toString());
			return;
		}
		
		//Read File
		try {
			while(reader.ready()) {
				line = reader.readLine();
				
				columns = line.split(",");
				
				if(columns[0].equals("ID") == false) {
					terrain = new Terrain(ChipSetPool.getInstance().getPoolItem(Integer.parseInt(columns[2])),columns[1],columns[3].equals("True"));
					
					items.put(Integer.parseInt(columns[0]),terrain);
				}
			}
		}
		catch(Exception e) {
			System.err.println("Error reading file" + filename);
			System.err.println(e.toString());
			return;
		}
		
		//Close File
		try {
			reader.close();
			fileStream.close();
		}
		catch(Exception e) {
			System.err.println("Error closing file" + filename);
			System.err.println(e.toString());
			return;
		}
	}
}
